#
# spec file for package perl-JSON
#
# Copyright (c) 2014 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           perl-JSON
Version:        2.90
Release:        32.1
%define cpan_name JSON
Summary:        JSON (JavaScript Object Notation) encoder/decoder
License:        Artistic-1.0 or GPL-1.0+
Group:          Development/Libraries/Perl
Url:            http://search.cpan.org/dist/JSON/
Source:         http://www.cpan.org/authors/id/M/MA/MAKAMAKA/%{cpan_name}-%{version}.tar.gz
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  perl
BuildRequires:  perl-macros
#BuildRequires: perl(JSON)
#BuildRequires: perl(JSON::backportPP)
#BuildRequires: perl(JSON::PP)
#BuildRequires: perl(JSON::XS)
#BuildRequires: perl(Tie::IxHash)
#BuildRequires: perl(_unicode_handling)
#Recommends:     perl(JSON::XS) >= 2.34
%{perl_requires}

%description
 *************************** CAUTION **************************************
 *                                                                        *
 * INCOMPATIBLE CHANGE (JSON::XS version 2.90)                            *
 *                                                                        *
 * JSON.pm had patched JSON::XS::Boolean and JSON::PP::Boolean internally *
 * on loading time for making these modules inherit JSON::Boolean.        *
 * But since JSON::XS v3.0 it use Types::Serialiser as boolean class.     *
 * Then now JSON.pm breaks boolean classe overload features and           *
 * -support_by_pp if JSON::XS v3.0 or later is installed.                 *
 *                                                                        *
 * JSON::true and JSON::false returned JSON::Boolean objects.             *
 * For workaround, they return JSON::PP::Boolean objects in this version. *
 *                                                                        *
 *     isa_ok(JSON::true, 'JSON::PP::Boolean');                           *
 *                                                                        *
 * And it discards a feature:                                             *
 *                                                                        *
 *     ok(JSON::true eq 'true');                                          *
 *                                                                        *
 * In other word, JSON::PP::Boolean overload numeric only.                *
 *                                                                        *
 *     ok( JSON::true == 1 );                                             *
 *                                                                        *
 **************************************************************************

 ************************** CAUTION ********************************
 * This is 'JSON module version 2' and there are many differences  *
 * to version 1.xx                                                 *
 * Please check your applications using old version.              *
 *   See to 'INCOMPATIBLE CHANGES TO OLD VERSION'                  *
 *******************************************************************

JSON (JavaScript Object Notation) is a simple data format. See to the
http://www.json.org/ manpage and 'RFC4627'(the
http://www.ietf.org/rfc/rfc4627.txt manpage).

This module converts Perl data structures to JSON and vice versa using
either the JSON::XS manpage or the JSON::PP manpage.

JSON::XS is the fastest and most proper JSON module on CPAN which must be
compiled and installed in your environment. JSON::PP is a pure-Perl module
which is bundled in this distribution and has a strong compatibility to
JSON::XS.

This module try to use JSON::XS by default and fail to it, use JSON::PP
instead. So its features completely depend on JSON::XS or JSON::PP.

See to the BACKEND MODULE DECISION manpage.

To distinguish the module name 'JSON' and the format type JSON, the former
is quoted by C<> (its results vary with your using media), and the latter
is left just as it is.

Module name : 'JSON'

Format type : JSON

%prep
%setup -q -n %{cpan_name}-%{version}

%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
%{__make} %{?_smp_mflags}

%check
%{__make} test

%install
%perl_make_install
%perl_process_packlist
%perl_gen_filelist

%files -f %{name}.files
%defattr(-,root,root,755)
%doc Changes README

%changelog
* Tue Nov 26 2013 coolo@suse.com
- updated to 2.90
  CAUTION!!!
  INCOMPATIBLE CHANGE
  JSON.pm had patched JSON::XS::Boolean and JSON::PP::Boolean internally
  on loading time for making these modules inherit JSON::Boolean.
  But since JSON::XS v3.0 it use Types::Serialiser as boolean class.
  Then now JSON.pm breaks boolean classe overload features and
  - support_by_pp if JSON::XS v3.0 or later is installed.
  JSON::true and JSON::false returned JSON::Boolean objects.
  For workaround, they return JSON::PP::Boolean objects in this version.
    isa_ok(JSON::true, 'JSON::PP::Boolean');
  And it discards a feature:
    ok(JSON::true eq 'true');
  In other word, JSON::PP::Boolean overload numeric only.
    ok( JSON::true == 1 );
* Mon Jun 10 2013 coolo@suse.com
- updated to 2.59
  - PUREPERL_ONLY support was not supported...
    and finally remove all PP options from Makefile.PL.
  - recommend JSON::XS instead of conditionally requiring it
    patched by miyagaw
    ( for example, $ cpanm --with-recommends JSON)
  - Hide more packages from PAUSE (and other stuff)
    patched by miyagawa
  - support PUREPERL_ONLY install option. (rt#84876)
    (PERL_ONLY and NO_XS are not yet removed)
  - stop installing JSON::XS automatically on Perl 5.18
  - t/x17_strage_overload.t didn't work correctly.
  - fixed t/x17_strage_overload.t (rt#84451 by Ricardo Signes)
  - update JSON::BackportPP version
  - fixed t/19_incr.t on perl >= 5.17.10 (wyant, rt#84154)
    pathced by mbeijen and modified with demerphq's patch
  - Fixed some spelling (by briandfoy)
  - fixed sppeling (by Perlover)
  - enhanced documents (Thanks to Justin Hunter and Olof Johansson)
  - changed backend module loading for overloaded object behavior
    (reported by tokuhirom)
- remove upstreamed fix_provides.diff
* Fri Nov 18 2011 coolo@suse.com
- update to 2.53
  - made Makefile.PL skipping a installing XS question
    when set $ENV{PERL_ONLY} or $ENV{NO_XS} (rt#66820)
  - fixed to_json (pointed and patched by mmcleric in rt#68359)
  - backport JSON::PP 2.27200
  * fixed incr_parse docodeing string more correctly (rt#68032 by LCONS)
* Tue Apr  5 2011 coolo@novell.com
- fix provides - JSON::PP is really another module
* Tue Mar  8 2011 pascal.bleser@opensuse.org
- update to 2.51:
  * import JSON::PP 2.27105 as BackportPP
  * JSON::PP is split away JSON distributino for perl 5.14
  * JSON::backportPP is included in instead
* Wed Dec  1 2010 coolo@novell.com
- switch to perl_requires macro
* Tue Sep 28 2010 pascal.bleser@opensuse.org
- update to 2.26:
  * JSON::PP: cleaned up code and enhanced sort option efficiency in encode
- changes from 2.25:
  * JSON: JSON::Backend::XS::Supportable always executed a needless process
    with JSON::XS backend; this made encode/decode a bit slower
- changes from 2.24:
  * JSON::PP:
    + tweaked code.
    + optimized code in hash object encoding
- changes from 2.23:
  * JSON::PP
    + modified tied object handling in encode; it made encoding speed faster
    (RT#61604)
    + modified t/e10_bignum.t for avoiding a warning in using Math::BigInt dev
    version
* Mon Sep  6 2010 chris@computersalat.de
- update to 2.22
  * added JSON::XS installing feature in Makefile.PL
    with cpan or cpanm (some points suggested by gfx)
  * check that to_json and from_json are not called as methods (CHORNY)
  * modified for -Duse64bitall -Duselongdouble compiled perl.
    11_pc_expo.t too. (these are patched by H.Merijn Brand)
- recreated by cpanspec 1.78
- noarch pkg
- remove blanks from changes file
* Wed Aug 25 2010 pascal.bleser@opensuse.org
- completely rewritten spec file
- updated to 2.22:
  * check that to_json and from_json are not called as methods
- changes from 2.21:
  * enhanced 'HOW DO I DECODE A DATA FROM OUTER AND ENCODE TO OUTER'
  * renamed eg/bench_pp_xs.pl to eg/bench_decode.pl
  * added eg/bench_encode.pl
- changes from 2.20:
  * added eg/bench_pp_xs.pl for benchmark sample
  * updated 'INCREMENTAL PARSING' section
  * decode_prefix() didn't count a consumed text length properly
  * enhanced XS compatibilty in the case of decoding a white space garbaged
    text
- changes from 2.19:
  * fixed typo (rt#53535 by Angel Abad)
  * added a recommendation refering to (en|de)code_json to pod
  * added 'HOW DO I DECODE A DATA FROM OUTER AND ENCODE TO OUTER'
- changs from 2.18:
  * updated document (compatible with JSON::XS 2.29)
  * fixed encode an overloaded 'eq' object bug
  * enhanced an error message compatible to JSON::XS
* Wed Jan 13 2010 jw@novell.com
- updated to 2.17
  * fixed a problem caused by JSON::XS backend and support_by_pp option
  (rt#52842,  rt#52847 by ikegami)
  [JSON::PP]
  * made compatible with JSON::XS 2.27
  * patched decode for incr_parse (rt#52820 by ikegami)
  * relaxed option caused an infinite loop in some condition.
* Sat Jul 25 2009 chris@computersalat.de
- spec mods
  * removed ^----------
  * removed ^#---------
* Sat Jun 20 2009 chris@computersalat.de
- update to 2.15
- added perl-macros
  o autogen filelist with perl_gen_filelist
- spec mods
  o added header
  o fixed deps
